<?xml version='1.0' encoding='UTF-8' ?>

<!--
IGAC proyecto SNC

@author fredy.wilches
@version 2.0
@description  Arbol de tareas y tabla de tareas masivas e individuales
@cu 

@modified leidy.gonzalez Se agrega columna de derecho de peticio o tutela
-->

<ui:composition xmlns="http://www.w3.org/1999/xhtml"
                xmlns:h="http://java.sun.com/jsf/html"
                xmlns:f="http://java.sun.com/jsf/core"
                xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns:p="http://primefaces.org/ui"
                xmlns:predio="http://java.sun.com/jsf/composite/predio"
                xmlns:misc="http://java.sun.com/jsf/composite/misc"
                xmlns:fn="http://java.sun.com/jsp/jstl/functions"
                xmlns:tramite="http://java.sun.com/jsf/composite/tramite"
                template="/templates/generalCU.xhtml">

    <ui:define name="title">.::Sistema Nacional Catastral::. .::Listado de Tareas Pendientes::.</ui:define>
    <!-- LISTADO DE TAREAS PENDIENTES­ -->
    <ui:define name="content">

        <p:ajaxStatus onstart="statusDialog2.show();"
                      onsuccess="statusDialog2.hide();" />

        <!--D: menú de opciones para funcionalidades que no van por el árbol de actividades -->
        <p:menubar model="#{menu.model}" style="float:none;" />


        <p:tabView id="tareasTab" dynamic="true">

            <p:ajax event="tabChange"
                    listener="#{tareasPendientes.onTabChange}" update="tareasTab" />

            <p:tab title="Actividades actuales" id="actividadesActualesTab"
                   rendered="#{!tareasPendientes.esOSMI}">
                <h:form id="tareasForm" onkeypress="return event.keyCode !== 13;">
                    <h:panelGrid columns="2" width="100%"
                                 columnClasses="columnOnTopArbol, columnOnTop" border="0">
                        <p:scrollPanel id="scroll" style="width:310px;height:650px">
                            <p:tree value="#{tareasPendientes.root}" var="node"
                                    id="arbolTareas" selectionMode="single"
                                    selection="#{tareasPendientes.nodoSeleccionado}">
                                <p:ajax event="select" onstart="statusDialog2.show()"
                                        oncomplete="redireccionar(document.getElementById('tareasTab:tareasForm:url').value)"
                                        listener="#{tareasPendientes.seleccionNodoListener}"
                                        update=":tareasTab:tareasForm:url,
                                        :tareasTab:tareasForm:panelDespliegueActividades,
                                        :tareasTab:tareasForm:scroll,:opcionActual" />
                                <p:treeNode>
                                    <h:outputText value="#{node}" />
                                </p:treeNode>
                            </p:tree>

                            <p:commandButton value="Refrescar las tareas pendientes"
                                             update="tareasTab:tareasForm"
                                             icon="ui-icon-refresh" label="Refrescar" title="Refrescar"
                                             immediate="true" process="@this"
                                             action="#{tareasPendientes.cargarInit}"
                                             ajax="false" 
                                             id="refrescarTareasPendientesBtn"/>

                        </p:scrollPanel>


                        <h:panelGrid id="panelDespliegueActividades" width="100%"
                                     columns="1" border="0">
                            <h:panelGrid id="panelTareas" columns="1"
                                         rendered="#{tareasPendientes.esNodoActividades}" width="100%"
                                         border="0">

                                <p:dataTable id="tablaTareas" var="tarea"
                                             value="#{tareasPendientes.listaInstanciasActividadesSeleccionadas}"
                                             paginator="true" rows="10" rowKey="#{tarea.id}"
                                             paginatorTemplate="{CurrentPageReport} {FirstPageLink} {PreviousPageLink} {PageLinks} {NextPageLink} {LastPageLink}"
                                             selection="#{tareasPendientes.instanciaSeleccionada}"
                                             selectionMode="single" paginatorPosition="bottom"
                                             dblClickSelect="true" emptyMessage="No hay tareas pendientes"
                                             rendered="#{tareasPendientes.esProcesoConservacion}">
                                    <p:ajax event="rowSelect"
                                            listener="#{tareasPendientes.onRowSelectNavigate}"
                                            onstart="statusDialog2.show();"
                                            oncomplete="redireccionar('#{request.contextPath}#{tareasPendientes.urlIndividual}')"></p:ajax>
                                    <p:column headerText="Actividad" sortBy="#{tarea.id}"
                                              rendered="#{tareasPendientes.esSubproceso}">
                                        <h:outputText value="#{tarea.actividad.arbolProceso}" />
                                    </p:column>
                                    <!-- Campos conservación  -->
                                    <p:column 
                                        filterBy="#{tarea.numeroRadicacion}"
                                        filterMatchMode="contains" sortBy="#{tarea.numeroRadicacion}"
                                        id="numRadicacionCln">
                                        <f:facet name="header">
                                            Número de <br>radicación</br>
                                        </f:facet>
                                        <h:outputText value="#{tarea.numeroRadicacion}" />
                                    </p:column>
                                    <p:column headerText="Número predial"
                                              filterBy="#{tarea.numeroPredial}" filterMatchMode="contains"
                                              sortBy="#{tarea.numeroPredial}">
                                        <h:outputText value="#{tarea.numeroPredial}" />
                                    </p:column>
                                    <p:column headerText="Tipo trámite"
                                              filterBy="#{tarea.tipoTramite}" filterMatchMode="contains"
                                              sortBy="#{tarea.tipoTramite}">
                                        <h:outputText value="#{tarea.tipoTramite}" />
                                    </p:column>

                                    <p:column headerText="Derecho Petición/Tutela"
                                              filterBy="#{tarea.observacion}" filterMatchMode="contains"
                                              sortBy="#{tareasPendientes.derechoPeticionTutela}">
                                        <h:outputText value="#{tareasPendientes.derechoPeticionTutela}" />
                                    </p:column>

                                    <!-- Campos comunes en las actividades  -->
                                    <p:column sortBy="#{tarea.fechaAsignacion}">
                                        <f:facet name="header">
                                            Fecha <br />de asignación
                                        </f:facet>
                                        <h:outputText value="#{tarea.fechaAsignacion}"
                                                      title="#{tarea.id}">
                                            <f:converter converterId="converterCalendar" />
                                        </h:outputText>
                                    </p:column>

                                    <p:column sortBy="#{tarea.fechaExpiracion}">
                                        <f:facet name="header">
                                            Fecha<br />expiración
                                        </f:facet>
                                        <h:outputText value="#{tarea.fechaExpiracion}">
                                            <f:converter converterId="converterCalendar" />
                                        </h:outputText>
                                    </p:column>

                                    <p:column style="text-align:center">
                                        <f:facet name="header">
                                            Proceso
                                        </f:facet>
                                        <p:commandLink ajax="true" immediate="true"
                                                       title="Ver proceso" oncomplete="procesoImgWV.show()"
                                                       update=":procesoImg">
                                            <p:graphicImage url="/images/proceso2.JPG"></p:graphicImage>
                                            <f:setPropertyActionListener value="#{tarea.id}"
                                                                         target="#{tareasPendientes.idTarea}" />
                                        </p:commandLink>
                                    </p:column>

                                </p:dataTable>
                                <!-- Vista de actividades de actualización -->
                                <p:dataTable id="tablaTareasActualizacion" var="tarea"
                                             value="#{tareasPendientes.listaInstanciasActividadesSeleccionadas}"
                                             paginator="true" rows="10"
                                             paginatorTemplate="{CurrentPageReport} {FirstPageLink} {PreviousPageLink} {PageLinks} {NextPageLink} {LastPageLink}"
                                             rowKey="#{tarea.id}"
                                             selection="#{tareasPendientes.instanciaSeleccionada}"
                                             selectionMode="single" paginatorPosition="bottom"
                                             dblClickSelect="true"
                                             style="position: absolute ; top : 65px; left : 340px; width: 70%"
                                             emptyMessage="No hay tareas pendientes"
                                             rendered="#{tareasPendientes.esProcesoActualizacion}">
                                    <p:ajax event="rowSelect"
                                            listener="#{tareasPendientes.onRowSelectNavigate}"
                                            onstart="statusDialog2.show();"
                                            oncomplete="redireccionar('#{request.contextPath}#{tareasPendientes.urlIndividual}')"></p:ajax>
                                    <p:column headerText="Actividad" sortBy="#{tarea.id}" filterBy="#{tarea.id}"
                                              rendered="#{tareasPendientes.esSubproceso}" filterMatchMode="contains">
                                        <h:outputText value="#{tarea.actividad.arbolProceso}" />
                                    </p:column>
                                    <!-- Campos de actualización -->
                                    <p:column headerText="Nro. Actualización" filterBy="#{tarea.numeroActualizacion}"
                                              sortBy="#{tarea.numeroActualizacion}" filterMatchMode="contains">
                                        <h:outputText value="#{tarea.numeroActualizacion}" />
                                    </p:column>
                                    <p:column headerText="Departamento"
                                              sortBy="#{tarea.idDepartamento}">
                                        <h:outputText value="#{tarea.idDepartamento}" >
                                            <f:converter converterId="converterDepartamentoNombre" />
                                        </h:outputText>
                                    </p:column>
                                    <p:column headerText="Municipio" sortBy="#{tarea.idMunicipio}"> 
                                        <h:outputText value="#{tarea.idMunicipio}">
                                            <f:converter converterId="converterMunicipioNombre"/>
                                        </h:outputText>
                                    </p:column>
                                    <!-- Campos comunes en las actividades  -->
                                    <p:column headerText="Fecha de asignación"
                                              sortBy="#{tarea.fechaAsignacion}">
                                        <h:outputText value="#{tarea.fechaAsignacion}"
                                                      title="#{tarea.id}">
                                            <f:converter converterId="converterCalendar" />
                                        </h:outputText>
                                    </p:column>									
                                </p:dataTable>

                                <!-- Vista de actividades de ofertas -->
                                <p:dataTable id="tablaTareasOfertas" var="tarea"
                                             value="#{tareasPendientes.listaInstanciasActividadesSeleccionadas}"
                                             paginator="true" rows="10"
                                             paginatorTemplate="{CurrentPageReport} {FirstPageLink} {PreviousPageLink} {PageLinks} {NextPageLink} {LastPageLink}"
                                             rowKey="#{tarea.id}"
                                             selection="#{tareasPendientes.instanciaSeleccionada}"
                                             selectionMode="single" paginatorPosition="bottom"
                                             dblClickSelect="true"
                                             style="position: absolute ; top : 65px; left : 340px; width: 70%"
                                             emptyMessage="No hay tareas pendientes"
                                             rendered="#{tareasPendientes.esProcesoOsmi}">
                                    <p:ajax event="rowSelect"
                                            listener="#{tareasPendientes.onRowSelectNavigate}"
                                            onstart="statusDialog2.show();"
                                            oncomplete="redireccionar('#{request.contextPath}#{tareasPendientes.urlIndividual}')"></p:ajax>
                                    <p:column headerText="Actividad" sortBy="#{tarea.id}"
                                              rendered="#{tareasPendientes.esSubproceso}">
                                        <h:outputText value="#{tarea.actividad.arbolProceso}" />
                                    </p:column>
                                    <!-- Campos de OSMI -->
                                    <p:column headerText="Área" sortBy="#{tarea.idObjetoNegocio}">
                                        <h:outputText value="#{tarea.idObjetoNegocio}" />
                                    </p:column>
                                    <p:column headerText="Departamento"
                                              sortBy="#{tarea.departamento.nombre}">
                                        <h:outputText value="#{tarea.departamento.nombre}" />
                                    </p:column>
                                    <p:column headerText="Municipio"
                                              sortBy="#{tarea.municipio.nombre}">
                                        <h:outputText value="#{tarea.municipio.nombre}" />
                                    </p:column>
                                    <p:column headerText="Zona" sortBy="#{tarea.zona.nombre}">
                                        <h:outputText value="#{tarea.zona.nombre}" />
                                    </p:column>
                                    <p:column headerText="Región" sortBy="#{tarea.idRegion}">
                                        <h:outputText value="#{tarea.idRegion}" />
                                    </p:column>
                                    <p:column headerText="Funcionario"
                                              sortBy="#{tarea.funcionario}">
                                        <h:outputText value="#{tarea.funcionario}" />
                                    </p:column>
                                    <!-- Campos comunes en las actividades  -->
                                    <p:column headerText="Fecha de asignación"
                                              sortBy="#{tarea.fechaAsignacion}">
                                        <h:outputText value="#{tarea.fechaAsignacion}"
                                                      title="#{tarea.id}">
                                            <f:converter converterId="converterCalendar" />
                                        </h:outputText>
                                    </p:column>
                                </p:dataTable>
                                <!-- Vista de actividades de control calidad ofertas -->
                                <p:dataTable id="tablaTareasOfertasControlCalidad" var="tarea"
                                             value="#{tareasPendientes.listaInstanciasActividadesSeleccionadas}"
                                             paginator="true" rows="10"
                                             paginatorTemplate="{CurrentPageReport} {FirstPageLink} {PreviousPageLink} {PageLinks} {NextPageLink} {LastPageLink}"
                                             rowKey="#{tarea.id}"
                                             selection="#{tareasPendientes.instanciaSeleccionada}"
                                             selectionMode="single" paginatorPosition="bottom"
                                             dblClickSelect="true"
                                             style="position: absolute ; top : 65px; left : 340px; width: 70%"
                                             emptyMessage="No hay tareas pendientes"
                                             rendered="#{tareasPendientes.esProcesoOsmiCalidad}">
                                    <p:ajax event="rowSelect"
                                            listener="#{tareasPendientes.onRowSelectNavigate}"
                                            onstart="statusDialog2.show();"
                                            oncomplete="redireccionar('#{request.contextPath}#{tareasPendientes.urlIndividual}')"></p:ajax>
                                    <p:column headerText="Actividad" sortBy="#{tarea.id}"
                                              rendered="#{tareasPendientes.esSubproceso}">
                                        <h:outputText value="#{tarea.actividad.arbolProceso}" />
                                    </p:column>
                                    <!-- Campos de OSMI -->
                                    <p:column headerText="Área" sortBy="#{tarea.idObjetoNegocio}">
                                        <h:outputText value="#{tarea.idObjetoNegocio}" />
                                    </p:column>
                                    <p:column headerText="Departamento"
                                              sortBy="#{tarea.departamento.nombre}">
                                        <h:outputText value="#{tarea.departamento.nombre}" />
                                    </p:column>
                                    <p:column headerText="Municipio"
                                              sortBy="#{tarea.municipio.nombre}">
                                        <h:outputText value="#{tarea.municipio.nombre}" />
                                    </p:column>
                                    <p:column headerText="Región" sortBy="#{tarea.idRegion}">
                                        <h:outputText value="#{tarea.idRegion}" />
                                    </p:column>
                                    <p:column headerText="Funcionario"
                                              sortBy="#{tarea.funcionario}">
                                        <h:outputText value="#{tarea.funcionario}" />
                                    </p:column>
                                    <!-- Campos comunes en las actividades  -->
                                    <p:column headerText="Fecha de asignación"
                                              sortBy="#{tarea.fechaAsignacion}">
                                        <h:outputText value="#{tarea.fechaAsignacion}"
                                                      title="#{tarea.id}">
                                            <f:converter converterId="converterCalendar" />
                                        </h:outputText>
                                    </p:column>
                                </p:dataTable>

                                <p:dataTable id="tablaTareasProductos" var="tarea"
                                             value="#{tareasPendientes.listaInstanciasActividadesSeleccionadas}"
                                             paginator="true" rows="10"
                                             paginatorTemplate="{CurrentPageReport} {FirstPageLink} {PreviousPageLink} {PageLinks} {NextPageLink} {LastPageLink}"
                                             rowKey="#{tarea.id}"
                                             selection="#{tareasPendientes.instanciaSeleccionada}"
                                             selectionMode="single" paginatorPosition="bottom"
                                             dblClickSelect="true"
                                             style="position: absolute ; top : 65px; left : 340px; width: 70%"
                                             emptyMessage="No hay tareas pendientes"
                                             rendered="#{tareasPendientes.esProcesoProductosCatastrales}">
                                    <p:ajax event="rowSelect"
                                            listener="#{tareasPendientes.onRowSelectNavigate}"
                                            onstart="statusDialog2.show();"
                                            oncomplete="redireccionar('#{request.contextPath}#{tareasPendientes.urlIndividual}')"></p:ajax>
                                    <p:column headerText="Actividad" sortBy="#{tarea.id}" filterBy="#{tarea.id}"
                                              rendered="#{tareasPendientes.esSubproceso}" filterMatchMode="contains">
                                        <h:outputText value="#{tarea.actividad.arbolProceso}" />
                                    </p:column>
                                    <!-- Campos de productos -->
                                    <p:column headerText="Nro. Solicitud" filterBy="#{tarea.numeroSolicitud}"
                                              sortBy="#{tarea.numeroSolicitud}" filterMatchMode="contains">
                                        <h:outputText value="#{tarea.numeroSolicitud}" />
                                    </p:column>
                                    <!-- Campos comunes en las actividades  -->
                                    <p:column headerText="Fecha de asignación"
                                              sortBy="#{tarea.fechaAsignacion}">
                                        <h:outputText value="#{tarea.fechaAsignacion}"
                                                      title="#{tarea.id}">
                                            <f:converter converterId="converterCalendar" />
                                        </h:outputText>
                                    </p:column>

                                    <p:column sortBy="#{tarea.fechaExpiracion}">
                                        <f:facet name="header">
                                            Fecha<br />expiración
                                        </f:facet>
                                        <h:outputText value="#{tarea.fechaExpiracion}">
                                            <f:converter converterId="converterCalendar" />
                                        </h:outputText>
                                    </p:column>									
                                </p:dataTable>

                            </h:panelGrid>
                        </h:panelGrid>
                        <h:inputHidden id="url"
                                       value="#{tareasPendientes.urlPagina}" />
                    </h:panelGrid>
                </h:form>
            </p:tab>
            <ui:remove>
                <p:tab title="Consulta predios" id="consultaGeneralPrediosTab">
                    <h:form id="busquedaSolicitudForm">


                        <p:commandButton value="Consultar predios" icon="ui-icon-home" id="btnConsultar" 
                                         ajax="true" immediate="true" onstart="statusDialog2.show();"
                                         oncomplete="statusDialog2.hide(); consultaPrediosDlgWV.show(); inicializarAutotab();">
                            <f:setPropertyActionListener value="2"
                                                         target="#{consultaPredio.listenerMethodIdentifier}" />
                        </p:commandButton>
                        <p:commandButton value="Cerrar" update="msgInfoFis"
                                         icon="ui-icon-circle-close" immediate="true"
                                         action="#{tareasPendientes.cerrar}" ajax="false"
                                         onstart="statusDialog2.show();" oncomplete="statusDialog2.hide();" />
                    </h:form>
                </p:tab>
            </ui:remove>
        </p:tabView>

        <p:dialog widgetVar="procesoImgWV" showEffect="fade" showHeader="true"
                  closable="true" dynamic="true" id="procesoImg" modal="true"
                  height="500" width="800" maximizable="true" appendToBody="true"
                  header="Proceso" draggable="false" resizable="true">
            <h:panelGrid cellpadding="5" cellspacing="5"
                         style="text-align:center;">
                <p:graphicImage url="#{tareasPendientes.imagenProceso}" height="1100" />
            </h:panelGrid>

        </p:dialog>


        <p:dialog header="Detalle de la solicitud" dynamic="true"
                  widgetVar="detalleSolicitudWV" modal="true" appendToBody="true"
                  resizable="true" position="center" height="480" width="960">
            <ui:include
                src="/conservacion/ejecucion/detalleSolicitudEjecutar.xhtml">
                <ui:param name="currentManagedBeanParam"
                          value="#{vistaDetallesSolicitud}" />
                <ui:param name="selectedSolicitudParam"
                          value="#{vistaDetallesSolicitud.solicitudSeleccionada}" />
                <ui:param name="tramiteResumenID"
                          value="" />
            </ui:include>
        </p:dialog>

        <p:dialog header="Detalle del trámite"
                  dynamic="true" widgetVar="detalleTramiteEjecutarWV" modal="false"
                  appendToBody="true" resizable="true" position="center" height="480"
                  width="960">
            <ui:include src="/conservacion/ejecucion/detalleTramiteEjecucion.xhtml">
                <ui:param name="currentManagedBeanParam"
                          value="#{vistaDetallesTramite}" />
                <ui:param name="currentDetallePredioWV" value="detallesPredioWV" />
            </ui:include>
        </p:dialog>     

        <predio:consultaPrediosCC id="cpCC" thisCCId="cpCC"
                                  managedBean="#{consultaPredio}" thisWVName="consultaPrediosDlgWV"
                                  ccIdsChain1=":psCC" ccIdsChain2=":dpCC"
                                  selectedPrediosWVName="prediosSeleccionadosDlgWV"
                                  mostrarBusquedaAvanzada="true" detallesPredioWV="detallesPredioWV"
                                  additionMethod1="#{consultaPredio.adicionarPredio1}"
                                  usePrediosButtonRendered="false"
                                  verPrediosSeleccionadosButtonRendered="false"
                                  usePrediosMethod="#{gestionarSolicitudes.adicionarPrediosAlTramite}"
                                  idsComponentsToUpdate=":msgsGSB" />

        <predio:prediosSeleccionadosCC id="psCC"
                                       managedBean="#{consultaPredio}"
                                       thisWVName="prediosSeleccionadosDlgWV" ccIdsChain="dpCC"
                                       detallesPredioWV="detallesPredioWV"
                                       usePrediosMethod="#{gestionarSolicitudes.adicionarPrediosAlTramite}"
                                       consultaPredioPredioWV="consultaPrediosDlgWV"
                                       usePrediosButtonRendered="true"
                                       idsComponentsToUpdate=":nuevoTramiteSolForm:contenedorPredios,:nuevoTramiteSolForm:msgsTramite, :nuevoTramiteSolForm:datosTramiteAutoavaluoEdicionPanelGrid" />

        <predio:detallesPredioCC id="dpCC" thisWVName="detallesPredioWV"
                                 mostrarDatosPropietarios="true" mostrarDatosTramites="true"
                                 mostrarFichaPredial="true" thisIdPlusColon=":dpCC" />

        <!-- Dialog usado para habilitar el tab de origen del predio -->
        <predio:detallesPredioCC id="dpCC2" thisWVName="detallePredioWV2"
                                 mostrarDatosPropietarios="true" mostrarDatosTramites="true"
                                 mostrarFichaPredial="true" thisIdPlusColon=":dpCC2" />

        <misc:docViewerWithCloseDecisionCC id="docViewer"
                                           confirmUpdate="msgInfoFis" confirmDialogWV="docViewerWV"
                                           ajaxBehavior="true"
                                           selectedDocumentAtt="#{previsualizacionDocumento.rutaArchivoTemporal}"
                                           showDownloadButton="#{previsualizacionDocumento.documentoDwg}"
                                           fileContent="#{previsualizacionDocumento.reporteDTO.streamedContentReporte}"
                                           doctypeAtt="#{vistaDetallesTramite.tipoMimeDocTemporal}"
                                           headerLabel="Previsualización de documento" yesRendered="false"
                                           noLabel="Cerrar" />

        <misc:visualizadorMemorandosCC
            id="viewReport"
            thisWVName="visorReporteWV"
            urlDocumento="#{consultaTramite.reporteDocumentoWaterMark.urlWebReporte}"
            fileContent="#{consultaTramite.reporteDocumentoWaterMark.streamedContentReporte}"
            documentoGenerado="#{consultaTramite.reporteDocumentoWaterMark ne null}"
            radicarButtonVisible="false"
            cancelButtonEnabled="false"/>


    </ui:define>
</ui:composition>